/*
注意S是接地不是接信号，——接信号而不是接地(和S调换了)；
模块采用超亮红外LED和光敏晶体管来探测手指的脉搏，一个红色LED灯会随着脉搏闪动
*/

int ledPin=16; //显示灯在16引脚
int sensorPin=A0; //传感器引脚在模拟输入第A0脚
double alpha=0.75; //修正值，用于增加平滑度
int period=20;
double change=0.0;
void setup()
{
  Serial.begin(115200);
  pinMode(sensorPin, INPUT);
  pinMode(ledPin,OUTPUT);
}
void loop()
{
  static double oldValue=0;
  static double oldChange=0;
  int rawValue=analogRead(sensorPin); //读取传感器的值
  Serial.println(rawValue);
  double value=alpha*oldValue+(1-alpha)*rawValue;
  change=value-oldValue;
  digitalWrite(ledPin,(change<0.0&&oldChange>0.0)); //输出
  oldValue=value;
  oldChange=change;
  delay(period);
}

