/*
霍尔磁力传感器能检测到磁场，从而输出检测信号。
模拟口能通过输出线性电压的变化来揭示出磁场的强弱。
数字输出口是达到某个阈值才会输出高低电平。可调电阻能改变检测的灵敏度。
编程原理
我们选择数字口作为输出，将D接开发板数字引脚4，使用板上的16脚和LED连通，
用于观察磁场的有无。当磁铁靠近时，16脚的灯灭，反之则亮。
*/
int Led=16;//定义LED 接口
int buttonpin=4; //定义线性霍尔传感器接口
int val;//定义数字变量val
void setup()
{
  pinMode(Led,OUTPUT);//定义LED 为输出接口
  pinMode(buttonpin,INPUT);//定义线性霍尔传感器为输出接口
}
void loop()
{
  val=digitalRead(buttonpin);//将数字接口4的值读取赋给val
  if(val==HIGH)//当霍尔传感器检测没有磁场信号时，LED亮
  {
    digitalWrite(Led,LOW);
  }
  else //当霍尔传感器检测到有磁场信号时，LED灭
  {
    digitalWrite(Led,HIGH);
  }
}


