/*
编程原理:
旋转编码器可通过旋转可以计数正方向和反方向转动过程中输出脉冲的次数，
增量编码器给出两相方波，它们的相位差90°，通常称为A通道和B通道。
其中一个通道给出与转速相关的信息，与此同时，通过两个通道信号进行顺序对比，
得到旋转方向的信息。
*/
const int interruptA = 0; // 中断 Interrupt 0 在 pin4 上
int CLK = 4; // PIN4 脉冲信号
int DAT = 5; // PIN3
int SW= 14; // PIN14 往下按压的开关信号
int LED1 = 15; // PIN15
int LED2 = 16; // PIN16  LED16是低电平有效!!
int COUNT = 0;
void setup()
{ 
  // 高电平变为低电平触发 ，调用中断处理子函数RoteStateChanged()
  attachInterrupt(interruptA, RoteStateChanged, FALLING); 
  pinMode(CLK, INPUT);
  digitalWrite(2, HIGH); // 上拉电阻
  pinMode(DAT, INPUT);
  digitalWrite(3, HIGH); // 上拉电阻
  pinMode(SW, INPUT);
  digitalWrite(4, HIGH); // 上拉电阻
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  Serial.begin(115200); //设置波特率为115200
}
void loop()
{ 
  if (!(digitalRead(SW))) //如果按下按钮
  { 
    COUNT = 0; //计数清零
    Serial.println("STOP COUNT = 0"); //串口输出清零
    digitalWrite(LED1, LOW); //LED1灯灭
    digitalWrite(LED2, HIGH); //LED2灯灭
    delay (2000); //延时2秒
  }
  Serial.println(COUNT); //如果没有按钮，输出计数值
}
void RoteStateChanged() //当CLK下降沿触发的时候，进入中断
{ 
  if (digitalRead(DAT)) // 当DAT为高电平时，是前进方向
  {
    COUNT++; //计数器累加
    digitalWrite(LED1, HIGH); // LED1亮
    digitalWrite(LED2, HIGH); //LED2 灭
    delay(20);
  }
  else // 当 DAT是低电平是反方向滚动
  {
    COUNT--; //计数器累减
    digitalWrite(LED2, LOW); // LED2亮
    digitalWrite(LED1, LOW); // LED1灭
    delay(20);
  }
}


