/*
该模块是基于热敏电阻（阻值随外界环境温度变化而变化）的工作原理，
能够实时感知周边环境温度的变化，我们把数据送到Arduino的模拟I/O口A0，
接来下我们只要经过简单的编程就能将传感器输出的数据转换为摄氏温度值，并加以显示，
使用起来还是方便、有效的呢，借此广泛应用于园艺、家庭警报系统等装置中。
*/
#include <math.h>
double Thermister(int RawADC)
{
  double Temp; 
  Temp = log(((10240000/RawADC)-10000));
  Temp = 1/(0.001129148+(0.000234125+(0.0000000876741*Temp*Temp))*Temp);
  Temp = Temp - 273.15;
  // 转换温度值;
  return Temp;
}
void setup()
{ 
  Serial.begin(115200);
}
void loop()
{ 
  Serial.print(Thermister(analogRead(A0))); // 输出转换好的温度值
  Serial.println("c");
  delay(500);
}

