/*
DHT11数字温湿度传感器是一款含有已校准数字信号输出的温湿度复合传感器，
它应用专用的数字模块采集技术和温湿度传感技术。
编程原理:
DHT11是一款数字式的温湿度传感器，使用一根信号
线传输数据。其读取步骤如下：
1、将该引脚改为输出模式，先将数据线的电平拉低（将该引脚置LOW)持续时间超过18MS以上。
2、再将该引脚置为高电平,持续时间40US.
3、再把该引脚设置为读取模式，此时读到低电平后，延时80US，再读到高电平后80US，
开始能接收到有效数据。
4、数据总共有5个字节，忽略校验位，有四位是有效数据。
第0字节是湿度的整数位，第1字节是湿度的小数为，
第2字节是温度的整数位，第3字节是温度的小数位。
*/
int DHpin = 4; //数字第4引脚读取
byte dat[5]; //设置5个字节的数组
byte read_data()
{ 
  byte data;
  for(int i=0; i<8; i++)
  { 
    if(digitalRead(DHpin) == LOW)
    { 
    while(digitalRead(DHpin) == LOW); //等待50us；
    delayMicroseconds(30); //判断高电平的持续时间，以判定数据是‘0’还是‘1’；
    if(digitalRead(DHpin) == HIGH) 
      data|=(1<<(7-i)); //高位在前，低位在后；
    while(digitalRead(DHpin) == HIGH); //数据‘1’，等待下一位的接收；
    }
  }
  return data;
}
void start_test()
{ 
  digitalWrite(DHpin,LOW); //拉低总线，发开始信号；
  delay(30); //延时要大于18ms，以便DHT11能检测到开始信号；
  digitalWrite(DHpin,HIGH);
  delayMicroseconds(40); //等待DHT11响应；
  pinMode(DHpin,INPUT); //改为输入读取模式
  while(digitalRead(DHpin) == HIGH);
  delayMicroseconds(80); //DHT11发出响应，拉低总线80us；
  if(digitalRead(DHpin) == LOW);
  delayMicroseconds(80); //DHT11拉高总线80us后开始发送数据；
  for(int i=0;i<4;i++) //接收温湿度数据，校验位不考虑；
    dat[i] = read_data();
  pinMode(DHpin,OUTPUT); //改为输出模式
  digitalWrite(DHpin,HIGH);//发送完一次数据后释放总线，等待主机的下一次开始信号；
}
void setup()
{ 
  Serial.begin(115200);
  pinMode(DHpin,OUTPUT);
}
void loop()
{
  start_test();
  Serial.print("Current humdity = ");
  Serial.print(dat[0], DEC); //显示湿度的整数位；
  Serial.print('.');
  Serial.print(dat[1],DEC); //显示湿度的小数位；
  Serial.println('%');
  Serial.print("Current temperature = ");
  Serial.print(dat[2], DEC); //显示温度的整数位；
  Serial.print('.');
  Serial.print(dat[3],DEC); //显示温度的小数位；
  Serial.println('C');
  delay(700);
}



