/***************本例在ESPDuino做不了，因为板上只有1个模拟口***********/
/*
具有(X,Y)2轴模拟输出，(Z)1路按钮数字输出。
配合Arduino传感器扩展板可以制作遥控器等互动作品。
接线方法：VRX接模拟0，VRY接模拟1，SW是按钮，接模拟口2；
编程原理：
该操纵杆本身是两个电位器（可调电阻）加一个按钮开关组成的。
拨动电位器，使得阻值发生变化，从而输出电压改变。
输出的是模拟量接模拟口。按钮输出的值由于电压低于2.5V，无法输出高电平，
按下后，输出0V，因此也用模拟口来读取。
*/
int Xaxis=A0; //定义X轴由模拟0端口读取
int Yaxis=A1; //定义Y轴由模拟1端口读取
int Zsw=A2; //定义Z按钮由模拟2端口读取（因为开关最大值低于2.5V）
int value = 0; //该变量读取模拟口的值
void setup()
{
  Serial.begin(9600);
}
void loop()
{ 
  value = analogRead(Xaxis); //读取模拟端口0
  Serial.print("X:");
  Serial.print(value, DEC);
  value = analogRead(Yaxis); //读取模拟端口1
  Serial.print(" | Y:");
  Serial.print(value, DEC);
  value = analogRead(Zsw); //读取模拟端口2
  Serial.print(" | Z: ");
  Serial.println(value, DEC);
  delay(100);
}

