/******************************************************
比水银开关多加了一个独立的LED，两个可以组成魔术光杯;
将魔术光杯其中一个模块S脚接数字脚4，LED控制接数字脚12（PWM功能），
另一个模块S脚接数字脚5，LED控制接数字脚13.
现象：当一个水银开关倾倒时，自己的灯会越来越暗，另一个灯会越来越亮，像心电感应一样。
*/

int ButtonPinA = 4;
int ButtonPinB = 5;
int LedPinA = A0;
int LedPinB = A1;
int buttonStateA = 0;
int buttonStateB = 0;
int brightness = 0;
void setup()
{
  pinMode(LedPinA, OUTPUT);
  pinMode(LedPinB, OUTPUT);
  pinMode(ButtonPinA, INPUT);
  pinMode(ButtonPinB, INPUT);
}
void loop()
{
  buttonStateA = digitalRead(ButtonPinA); //读取A模块
  if (buttonStateA == HIGH && brightness != 255)
  { 
    //当A模块检测到信号，且亮度不是最大时，亮度值增加
    brightness ++;
  }
  buttonStateB = digitalRead(ButtonPinB);
  if (buttonStateB == HIGH && brightness != 0)
  {
    //当B模块检测到信号，且亮度不是最小时，亮度值减小
    brightness --;
  }
  analogWrite(LedPinA, brightness); // A慢漸暗   这里要用到两个模拟口，所以这板也用不了
  analogWrite(LedPinB, 255 - brightness); // B慢漸亮
  delay(25);
}
//两者相加的和为255，亮度此消彼涨的关系

